/*
 This file is part of GACC.
 
 GACC is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 GACC is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */
//
//  AppDelegate.m
//  Gacc
//
//  Created by Xavi Pregona Soto on 4/5/15.
//  Copyright (c) 2015 XPS. All rights reserved.
//

#import "AppDelegate.h"
#import "XPSActivityModel.h"
#import "XPSActivityViewController.h"
#import "IniciViewController.h"
#import "XPSCercaTableTableViewController.h"
#import "XPSProfileTableViewController.h"
#import "XPSNearActivitiesTableViewController.h"

@interface AppDelegate ()

@end

@implementation AppDelegate

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    self.window = [[UIWindow alloc] initWithFrame:[[UIScreen mainScreen] bounds]];
    
    //COMPROVEM SI HA DADES GUARDADES DE L'ÚLTIM USUARI I LES BORREM EN CAS QUE AFIRMATIU
    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
    if ([defaults objectForKey:@"userMail"]) {
        [defaults removeObjectForKey:@"userMail"];
        [defaults removeObjectForKey:@"favorits"];
    }
    
    //ESTRUCTURA DE CONTROLADORS DEL TAB BAR
    IniciViewController *inici = [[IniciViewController alloc] init];
    XPSCercaTableTableViewController *cercaVC = [[XPSCercaTableTableViewController alloc] initWithStyle:UITableViewStyleGrouped];
    XPSProfileTableViewController *profileVC = [[XPSProfileTableViewController alloc] initWithStyle:UITableViewStylePlain];
    XPSNearActivitiesTableViewController *nearVC = [[XPSNearActivitiesTableViewController alloc] initWithStyle:UITableViewStylePlain];
    
    //INICIACIÓ DE NAVIGATIONS DEL TAB BAR
    UINavigationController *iniciNavVC = [[UINavigationController alloc] initWithRootViewController:inici];
    UINavigationController *cercaNavVC = [[UINavigationController alloc] initWithRootViewController:cercaVC];
    UINavigationController *perfilNavVC = [[UINavigationController alloc] initWithRootViewController:profileVC];
    UINavigationController *aPropNavVC = [[UINavigationController alloc] initWithRootViewController:nearVC];
    
    //INICIACIÓ DEL TAB BAR
    UITabBarController *tabVC = [[UITabBarController alloc] init];

    //COLORS TAB BAR I NAVIGATIONS BAR
    UIColor *blueColor = [UIColor colorWithRed:0.1372549 green:0.41568627 blue:0.68627451 alpha:1];
    
    tabVC.tabBar.barTintColor = blueColor;
    tabVC.tabBar.tintColor = [UIColor whiteColor];
    
    iniciNavVC.navigationBar.barTintColor = blueColor;
    iniciNavVC.navigationBar.titleTextAttributes = @{NSForegroundColorAttributeName : [UIColor whiteColor]};
    
    cercaNavVC.navigationBar.barTintColor = blueColor;
    cercaNavVC.navigationBar.titleTextAttributes = @{NSForegroundColorAttributeName : [UIColor whiteColor]};
    
    perfilNavVC.navigationBar.barTintColor = blueColor;
    perfilNavVC.navigationBar.titleTextAttributes = @{NSForegroundColorAttributeName : [UIColor whiteColor]};
    
    aPropNavVC.navigationBar.barTintColor = blueColor;
    aPropNavVC.navigationBar.titleTextAttributes = @{NSForegroundColorAttributeName : [UIColor whiteColor]};
    
    
    
    //ASSIGNACIÓ DE NAVIGATIONS AL TAB BAR
    tabVC.viewControllers = @[iniciNavVC, perfilNavVC, cercaNavVC, aPropNavVC];
    
    //ASSIGNACIÓ VISTA INICIAL
    self.window.rootViewController = tabVC;
    
    // Override point for customization after application launch.    
    self.window.backgroundColor = [UIColor whiteColor];
    [self.window makeKeyAndVisible];
    return YES;
}

- (void)applicationWillResignActive:(UIApplication *)application {
    // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
    // Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
}

- (void)applicationDidEnterBackground:(UIApplication *)application {
    // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later.
    // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
}

- (void)applicationWillEnterForeground:(UIApplication *)application {
    // Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
}

- (void)applicationDidBecomeActive:(UIApplication *)application {
    // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
}

- (void)applicationWillTerminate:(UIApplication *)application {
    // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
}

@end
