/*
 This file is part of GACC.
 
 GACC is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 GACC is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */
//
//  IniciViewController.m
//  Gacc
//
//  Created by Xavi Pregona Soto on 4/5/15.
//  Copyright (c) 2015 XPS. All rights reserved.
//

#import "IniciViewController.h"
#import "XPSRegistreViewController.h"
#import "XPSLoginViewController.h"
#import "XPSCercaTableTableViewController.h"
#import "XPSNearActivitiesTableViewController.h"

@interface IniciViewController ()

@end

@implementation IniciViewController

-(id) init
{
    if (self = [super init]) {
        
        //ASSIGNEM TÍTOL I IMATGE PER L'ITEM DEL TAB BAR
        self.title = @"Inici";
        [self.tabBarItem setImage:[[UIImage imageNamed:@"house"] imageWithRenderingMode:UIImageRenderingModeAlwaysOriginal]];
        [self.tabBarItem setSelectedImage:[[UIImage imageNamed:@"houseB"] imageWithRenderingMode:UIImageRenderingModeAlwaysOriginal]];
        [self.tabBarItem setTitleTextAttributes:@{NSForegroundColorAttributeName: [UIColor blackColor]} forState:UIControlStateNormal];
        [self.tabBarItem setTitleTextAttributes:@{NSForegroundColorAttributeName: [UIColor whiteColor]} forState:UIControlStateSelected];

    }
    
    return self;
}

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

-(void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    
    //SI L'USUARI HA FET LOGIN ES MOSTRA MISSATGE DE BENVINGUDA
    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
    if ([defaults objectForKey:@"userMail"]) {
        self.welcome.text = @"Benvingut";
        self.userMail.text = [defaults objectForKey:@"userMail"];
    } else {
        self.welcome.text = @"GACC";
        self.userMail.text = @"Guia d'Activitats Culturals de Catalunya";
    }
    
}

#pragma mark - Actions

//MOSTRA VISTA PER FER REGISTRE
-(IBAction)displayRegisterScreen:(id)sender
{
    XPSRegistreViewController *registerVC = [[XPSRegistreViewController alloc] init];
    
    [self.navigationController pushViewController:registerVC animated:YES];
}

//MOSTRA VISTA PER FER EL LOGIN
-(IBAction)displayLoginScreen:(id)sender
{
    XPSLoginViewController *loginVC = [[XPSLoginViewController alloc] init];
    
    [self.navigationController pushViewController:loginVC animated:YES];
}

//MOSTRA LA VISTA DE CERCA D'ACTIVITATS
-(IBAction)displayActivitySearchScreen:(id)sender
{
    
    NSArray *vc = [self.tabBarController viewControllers];
    
    [self.tabBarController setSelectedViewController:[vc objectAtIndex:2]];
    
}

//MOSTRA LA VISTA D'ACTIVITATS PER PROXIMITAT
-(IBAction)displayNearActivitiesScreen:(id)sender
{
    
    NSArray *vc = [self.tabBarController viewControllers];
    
    [self.tabBarController setSelectedViewController:[vc objectAtIndex:3]];
}

@end
