/*
 This file is part of GACC.
 
 GACC is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 GACC is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */
//
//  XPSActivitiesListTableViewController.m
//  Gacc
//
//  Created by Xavi Pregona Soto on 10/5/15.
//  Copyright (c) 2015 XPS. All rights reserved.
//

#import "XPSActivitiesListTableViewController.h"
#import "XPSActivityModel.h"
#import "XPSActivityViewController.h"
#import "CustomCell.h"
#import "../SDWebImage/UIImageView+WebCache.h"

@interface XPSActivitiesListTableViewController ()

@end

@implementation XPSActivitiesListTableViewController

-(id) initWithStyle:(UITableViewStyle)style
          withArray: (NSArray *) activitiesList
{
    
    if (self = [super initWithStyle:style]) {
        _activities = activitiesList;
        
        //TÍTOL DE LA TAULA
        self.title = @"Llista activitats";
    }
    
    return self;
    
}

- (void)viewDidLoad {
    [super viewDidLoad];
    
    self.navigationController.navigationBar.tintColor = [UIColor whiteColor];
    
    // Uncomment the following line to preserve selection between presentations.
    // self.clearsSelectionOnViewWillAppear = NO;
    
    // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
    // self.navigationItem.rightBarButtonItem = self.editButtonItem;
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {

    // Return the number of sections.
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {

    // Return the number of rows in the section.
    return [self.activities count];
}


- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    CustomCell *cell = [tableView dequeueReusableCellWithIdentifier:@"customCell"];
    
    if (!cell) {
        [tableView registerNib:[UINib nibWithNibName:@"CustomCell" bundle:nil] forCellReuseIdentifier:@"customCell"];
        cell = [tableView dequeueReusableCellWithIdentifier:@"customCell"];
    }
    
    //RECUPEREM ACTIVITAT
    XPSActivityModel *activity = [self.activities objectAtIndex:indexPath.row];
    
    cell.name.text = activity.name;
    cell.category.text = activity.category;
    cell.place.text = [NSString stringWithFormat:@"%@\n%@", activity.place, activity.city];
    
    //COMPROVACIÓ PER ESTAR SEGURS QUE ES CARREGA LA IMATGE CORRECTAMENT JA QUE LA RUTA PROPORCIONADA
    //DES DE LA FONT DE DADES I LA RUTA REAL SÓN DIFERENTS
    NSString *url = [NSString stringWithFormat:@"%@", activity.photoURL];
    NSRange agenda = [url rangeOfString:@"agenda/"];
    
    if (agenda.location != NSNotFound) {
        url = [url stringByReplacingCharactersInRange:agenda withString:@""];
        NSURL *theURL = [NSURL URLWithString:url];
        [cell.photo sd_setImageWithURL:theURL placeholderImage:[UIImage imageNamed:@"image"]];
    } else {
        
        [cell.photo sd_setImageWithURL:activity.photoURL placeholderImage:[UIImage imageNamed:@"image"]];
    }
    
    return cell;
}

-(void) tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    //RECUPEREM INFORMACIÓ DE L'ACTIVITAT
    XPSActivityModel *activity = [self.activities objectAtIndex:indexPath.row];
    
    //INICIEM VISTA ACTIVITAT
    XPSActivityViewController *activityVC = [[XPSActivityViewController alloc] initWithModel:activity];
    
    //MOSTREM VISTA ACTIVITAT
    [self.navigationController pushViewController:activityVC animated:YES];
    
}

-(CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath
{
    return 137.0;
}
@end
