/*
 This file is part of GACC.
 
 GACC is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 GACC is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */
//
//  XPSActivityModel.h
//  Gacc
//
//  Created by Xavi Pregona Soto on 4/5/15.
//  Copyright (c) 2015 XPS. All rights reserved.
//

#import <Foundation/Foundation.h>
@import UIKit;

@interface XPSActivityModel : NSObject

//PROPIETATS
@property (nonatomic, strong) NSString *name;
@property (nonatomic, strong) NSString *pk;
@property (nonatomic, strong) NSString *descript;
@property (nonatomic, strong) NSString *initialDate;
@property (nonatomic, strong) NSString *endDate;
@property (nonatomic, strong) NSString *schedule;
@property (nonatomic, strong) NSString *place;
@property (nonatomic, strong) NSString *address;
@property (nonatomic, strong) NSString *city;
@property (nonatomic, strong) NSString *comarca;
@property (nonatomic, strong) NSString *cp;
@property (nonatomic, strong) NSString *phone;
@property (nonatomic, strong) NSString *url;
@property (nonatomic, strong) NSString *price;
@property (nonatomic, strong) NSString *category;
@property (nonatomic, strong) NSURL *photoURL;
@property (strong, nonatomic, readonly) UIImage *photo;
@property (nonatomic, strong) NSNumber *distance;


//INICIADORS DE CONVENIÈNCIA SEGONS LES NOSTRES NECESSITATS
-(id) initWithName: (NSString *)name
                pk: (NSString *)pk
       description: (NSString *)descript
          initDate: (NSString *)initialDate
           endDate: (NSString *)endDate
          schedule: (NSString *)schedule
             place: (NSString *)place
           address: (NSString *)address
              city: (NSString *)city
           comarca: (NSString *)comarca
        postalCode: (NSString *)cp
             phone: (NSString *)phone
               web: (NSString *)url
             price: (NSString *)price
          category: (NSString *)category
             photo: (NSURL *)photoURL
          distance: (NSNumber *)distance;

-(id) initwithDictionary: (NSDictionary *)aDict;

@end
