/*
 This file is part of GACC.
 
 GACC is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 GACC is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */
//
//  XPSActivityViewController.h
//  Gacc
//
//  Created by Xavi Pregona Soto on 4/5/15.
//  Copyright (c) 2015 XPS. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "XPSActivityModel.h"
#import <MessageUI/MessageUI.h>

@interface XPSActivityViewController : UIViewController <NSURLConnectionDataDelegate, MFMailComposeViewControllerDelegate>

//IBOUTLETS
@property (strong, nonatomic) XPSActivityModel *model;
@property (weak, nonatomic) IBOutlet UILabel *name;
@property (weak, nonatomic) IBOutlet UIImageView *photo;
@property (weak, nonatomic) IBOutlet UILabel *address;
@property (weak, nonatomic) IBOutlet UILabel *contact;
@property (weak, nonatomic) IBOutlet UILabel *price;
@property (strong, nonatomic) IBOutlet UIScrollView *scrollView;
@property (weak, nonatomic) IBOutlet UIButton *favorite;
@property (weak, nonatomic) IBOutlet UILabel *descript;

//IBACTIONS
-(IBAction)displayMap:(id)sender;
-(IBAction)manageFavorite:(id)sender;
-(IBAction)sendMail:(id)sender;

//PROPIETATS
@property (strong, nonatomic) NSMutableData *responseData;

//INCIALITZADOR DE CONVENIÈNCIA SEGONS LES NOSTRES NECESSITATS
- (id)initWithModel:(XPSActivityModel *)aModel;

@end
