/*
 This file is part of GACC.
 
 GACC is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 GACC is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */
//
//  XPSOptionsSearchTableViewController.h
//  Gacc
//
//  Created by Xavi Pregona Soto on 6/5/15.
//  Copyright (c) 2015 XPS. All rights reserved.
//

#import <UIKit/UIKit.h>

@class XPSOptionsSearchTableViewController;

//DEFINIM DELEGAT PERSONALITZAT PER ENVIAR INFORMACIÓ AL CONTROLADOR QUE FARA LA CERCA D'ACTIVITATS
@protocol OptionsSearchTableViewControllerDelegate <NSObject>

//METODES DEL DELEGAT
-(void) OptionsSearchTableViewController: (XPSOptionsSearchTableViewController *) optionsVC didSelectedProvincia: (NSString *) provincia indexPath: (NSIndexPath *) indexPath;
-(void) OptionsSearchTableViewController: (XPSOptionsSearchTableViewController *) optionsVC didSelectedPoble: (NSString *) poble indexPath: (NSIndexPath *) indexPath;
-(void) OptionsSearchTableViewController: (XPSOptionsSearchTableViewController *) optionsVC didSelectedCategory: (NSString *) categoria indexPath: (NSIndexPath *) indexPath;

@end

@interface XPSOptionsSearchTableViewController : UITableViewController<NSURLConnectionDataDelegate>

//PROPIETATS
@property (strong, nonatomic) NSArray *provincies;
@property (strong, nonatomic) NSIndexPath *currentSelected;
@property (strong, nonatomic) NSIndexPath *currentSel;
@property (strong, nonatomic) NSArray *pobles;
@property (strong, nonatomic) NSArray *categories;

//PROPIETATS PER SABER LA INFORMACIÓ QUE ES MOSTRA
@property BOOL tableProvincies;
@property BOOL tablePobles;
@property BOOL tableCategories;

//PROPIETAT ON S'EMMAGATZEMEN LES DADES RETORNADES DEL SERVEI WEB
@property (strong, nonatomic) NSMutableData *responseData;

//DELEGATE
@property (nonatomic, weak) id<OptionsSearchTableViewControllerDelegate> delegate;

//INICIALITZADORS PER TAULA DE PROVINCIES
-(id)initWithStyle:(UITableViewStyle)style
             array: (NSArray *) anArray
          selected: (NSIndexPath *) selected;

//INICIALITZADOR PER TAULA DE POBLES
-(id)initWithStyle:(UITableViewStyle)style
     withProvincia:(NSString *)anProvincia
          selected: (NSIndexPath *) selected;

//INICIALITZADOR PER TAULA DE CATEGORIES
-(id)initWithStyle:(UITableViewStyle)style
     withProvincia:(NSString *)anProvincia
         withPoble: (NSString *) anPoble
          selected: (NSIndexPath *) selected;

@end
