/*
 This file is part of GACC.
 
 GACC is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 GACC is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */
//
//  XPSOptionsSearchTableViewController.m
//  Gacc
//
//  Created by Xavi Pregona Soto on 6/5/15.
//  Copyright (c) 2015 XPS. All rights reserved.
//

#import "XPSOptionsSearchTableViewController.h"

@import Foundation;

@interface XPSOptionsSearchTableViewController ()

@property (strong, nonatomic) UIActivityIndicatorView *ai;

@end

@implementation XPSOptionsSearchTableViewController

//INICIALITZADOR TAULA DE PROVINCIES
-(id)initWithStyle:(UITableViewStyle)style
             array: (NSArray *) anArray
          selected:(NSIndexPath *)selected
{
    if (self = [super initWithStyle:style]) {
        
        //TÍTOL DE LA TAULA
        self.title = @"Provincies";
        
        //INDIQUEM QUE ES TRACTA DE LA TAULA DE PROVINCIES
        _provincies = anArray;
        _tableCategories = NO;
        _tablePobles = NO;
        _tableProvincies = YES;
        _currentSel = selected;
        
    }
    
    return self;
}

//INICIALITADOR TAULA DE POBLES
-(id)initWithStyle:(UITableViewStyle)style
     withProvincia:(NSString *)anProvincia
          selected:(NSIndexPath *)selected
{
    if (self = [super initWithStyle:style]) {
        
        //TÍTOL DE LA TAULA
        self.title = @"Poblacions";
        
        //INDIQUEM QUE ES TRACTA DE LA TAULA DE POBLES
        _tableCategories = NO;
        _tablePobles = YES;
        _tableProvincies = NO;
        _currentSel = selected;
        
        //PREPAREM URL PER FER LA CONSULTA SEGONS SI HI HA PROVINCIA SELECCIONADA O NO
        NSString *url;
        NSString *baseUrl;
        baseUrl = @"http://gacc.esy.es/pobles.php?provincia=";
        
        if (anProvincia != nil) {
            
            if (![anProvincia isEqualToString:@"Totes les provincies"]) {
                
                url = [baseUrl stringByAppendingString:anProvincia];
                
            } else {
                
                url = [baseUrl stringByAppendingString:@"tots"];
                
            }
            
        } else {
            
            url = [baseUrl stringByAppendingString:@"tots"];
            
        }
        
        //PREPARACIÓ DE LA PETICIÓ AL SERVEI WEB
        NSURLRequest *request = [NSURLRequest requestWithURL:[NSURL URLWithString:[url stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding]]];
        
        //CONNEXIO ASÍNCRONA
        NSURLConnection *conn = [[NSURLConnection alloc] initWithRequest:request delegate:self];
        [conn start];
        
        //INDICADOR PER DONCAR FEEDBACK A L'USUARI QUE S'ESTAN CARREGANT LES DADES
        self.ai = [[UIActivityIndicatorView alloc] initWithActivityIndicatorStyle:UIActivityIndicatorViewStyleGray];
        self.ai.frame = CGRectMake(self.view.frame.size.width / 2.0, (self.view.frame.size.height / 2) - 150, 0, 0);
        CGAffineTransform transform = CGAffineTransformMakeScale(2.0f, 2.0f);
        self.ai.transform = transform;
        [self.ai startAnimating];
        [self.view addSubview:self.ai];
        
        }
    
    return self;
}

//INICIALITADOR TAULA DE CATEGORIES
-(id)initWithStyle:(UITableViewStyle)style
     withProvincia:(NSString *)anProvincia
         withPoble: (NSString *) anPoble
          selected:(NSIndexPath *)selected
{
    
    if (self = [super initWithStyle:style]) {
        
        //TÍTOL DE LA TAULA
        self.title = @"Categories";
        
        //INDIQUEM QUE ES TRACTA DE LA TAULA DE CATEGORIES
        _tableCategories = YES;
        _tablePobles = NO;
        _tableProvincies = NO;
        _currentSel = selected;
        
        //PREPAREM URL PER FER LA CONSULTA SEGONS SI HI HA PROVINCIA SELECCIONADA O NO
        NSString *url;
        NSString *baseUrl;
        
        if (![anPoble isEqualToString:@"tots"]) { //HI HA POBLE
            
            baseUrl = @"http://gacc.esy.es/categories.php?poblacio=";
            
            if (![anPoble isEqualToString:@"Tots els pobles"]) {
                
                NSArray *words = [anPoble componentsSeparatedByString:@" "];
                anPoble = [words componentsJoinedByString:@"+"];
                
                //FORMAT DEL POBLE SI EL NOM CONTE CARÀCTERS AMB APÒSTROFS
                NSString *symbol = @"'";
                NSRange range = [anPoble rangeOfString:symbol options:NSCaseInsensitiveSearch];
                
                if (range.location != NSNotFound) {
                    words = [anPoble componentsSeparatedByString:@"'"];
                    anPoble = [words componentsJoinedByString:@"!"];
                }
                
                url = [baseUrl stringByAppendingString:anPoble];
                
            } else {
                
                url = [baseUrl stringByAppendingString:@"tots"];
                
            }
            
        
        } else { //NO HI HA POBLE
            
            baseUrl = @"http://gacc.esy.es/categories.php?provincia=";
            
            if (![anProvincia isEqualToString:@"tots"]) { //HI HA PROVINCIA
                
                    
                url = [baseUrl stringByAppendingString:anProvincia];
                
                
            } else { //NO HI HA PROVINCIA
                
                url = [baseUrl stringByAppendingString:@"tots"];
                
                
            }
            
        }
        
        //PREPARACIÓ DE LA PETICIÓ AL SERVEI WEB
        NSURLRequest *request = [NSURLRequest requestWithURL:[NSURL URLWithString:[url stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding]]];
        
        //CONNEXIO ASÍNCRONA
        NSURLConnection *conn = [[NSURLConnection alloc] initWithRequest:request delegate:self];
        [conn start];
        
        //INDICADOR PER DONCAR FEEDBACK A L'USUARI QUE S'ESTAN CARREGANT LES DADES
        self.ai = [[UIActivityIndicatorView alloc] initWithActivityIndicatorStyle:UIActivityIndicatorViewStyleGray];
        self.ai.frame = CGRectMake(self.view.frame.size.width / 2.0, (self.view.frame.size.height / 2) - 150, 0, 0);
        CGAffineTransform transform = CGAffineTransformMakeScale(2.0f, 2.0f);
        self.ai.transform = transform;
        [self.ai startAnimating];
        [self.view addSubview:self.ai];
        
    }
    
    return self;

    
}


- (void)viewDidLoad {
    [super viewDidLoad];
    self.navigationItem.rightBarButtonItem = [[UIBarButtonItem alloc] initWithTitle:@"Fet" style:UIBarButtonItemStylePlain target:self action:@selector(returnBack)];
    
    self.navigationController.navigationBar.tintColor = [UIColor whiteColor];
    
    // Uncomment the following line to preserve selection between presentations.
    // self.clearsSelectionOnViewWillAppear = NO;
    
    // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
    // self.navigationItem.rightBarButtonItem = self.editButtonItem;
}

-(void) viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {

    // Return the number of sections.
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {

    // Return the number of rows in the section.
    if (self.tableProvincies) {
        return [self.provincies count];
    } else if (self.tablePobles) {
        return [self.pobles count];
    } else {
        return [self.categories count];
    }
    
}

- (UITableViewCell *)tableView:(UITableView *)tableView
         cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    if (self.tableProvincies) { //TAULA DE PROVINCIES
        
        static NSString *cellIdentifier = @"provinciesCell";
        
        //REUTILITZEM CELLS SI N'HI HA
        UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:cellIdentifier];
        
        //CREA NOVA CELL SI NO S'EN POT REAPROFITAR CAP ALTRE
        if (cell == nil) {
            cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:cellIdentifier];
        }
        
        //ASSIGNEM INFORMACIÓ A LES PROPIETATS DE LA CELL
        cell.textLabel.text = [self.provincies objectAtIndex:indexPath.row];
        if (indexPath.row == self.currentSel.row) {
            [cell setAccessoryType:UITableViewCellAccessoryCheckmark];
        }
    
        return cell;
        
    } else if (self.tablePobles) { //TAULA DE POBLES
        
        static NSString *cellIdentifier = @"poblesCell";
        
        //REUTILITZEM CELLS SI N'HI HA
        UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:cellIdentifier];
        
        //CREA NOVA CELL SI NO S'EN POT REAPROFITAR CAP ALTRE
        if (cell == nil) {
            cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:cellIdentifier];
        }
        
        //ASSIGNEM INFORMACIÓ A LES PROPIETATS DE LA CELL
        cell.textLabel.text = [self.pobles objectAtIndex:indexPath.row];
        if (indexPath.row == self.currentSel.row) {
            //[cell setAccessoryType:UITableViewCellAccessoryCheckmark];
        }
        
        return cell;
        
    } else { //TAULA DE CATEGORIES
        
        static NSString *cellIdentifier = @"categoriesCell";
        
        //REUTILITZEM CELLS SI N'HI HA
        UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:cellIdentifier];
        
        //CREA NOVA CELL SI NO S'EN POT REAPROFITAR CAP ALTRE
        if (cell == nil) {
            cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:cellIdentifier];
        }
        
        ///ASSIGNEM INFORMACIÓ A LES PROPIETATS DE LA CELL
        cell.textLabel.text = [self.categories objectAtIndex:indexPath.row];
        if (indexPath.row == self.currentSel.row) {
            [cell setAccessoryType:UITableViewCellAccessoryCheckmark];
        }
        
        return cell;
        
    }
    
}

-(void) tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    
    
    if (self.tableProvincies) { //TAULA DE PROVINCIES
        
        //OBTENIM LA CELL
        UITableViewCell *cell = [tableView cellForRowAtIndexPath:indexPath];
        
        if (cell.accessoryType == UITableViewCellAccessoryNone) { //NO ESTA SELECCIONADA
            
            [cell setAccessoryType:UITableViewCellAccessoryCheckmark]; //SELECCIONA CELL
            
            //ACTUALITZA CELL SELECCIONADA
            UITableViewCell *oldCell = [tableView cellForRowAtIndexPath:self.currentSel];
            [oldCell setAccessoryType:UITableViewCellAccessoryNone];
            self.currentSel = indexPath;
            
            //ENVIA INFORMACIÓ A TRAVÉS DEL SEU DELEGAT
            [self.delegate OptionsSearchTableViewController:self didSelectedProvincia:cell.textLabel.text indexPath:indexPath];
        
        }
           
    } else if (self.tablePobles) { //TAULA DE POBLES
        
        //OBTENIM LA CELL
        UITableViewCell *cell = [tableView cellForRowAtIndexPath:indexPath];
        
        if (cell.accessoryType == UITableViewCellAccessoryNone) { //NO ESTA SELECCIONADA
            
            [cell setAccessoryType:UITableViewCellAccessoryCheckmark]; //SELECCIONA CELL
            
            //ACTUALITZA CELL SELECCIONADA
            UITableViewCell *oldCell = [tableView cellForRowAtIndexPath:self.currentSel];
            [oldCell setAccessoryType:UITableViewCellAccessoryNone];
            self.currentSel = indexPath;
            
            //ENVIA INFORMACIÓ A TRAVÉS DEL SEU DELEGAT
            [self.delegate OptionsSearchTableViewController:self didSelectedPoble:cell.textLabel.text indexPath:indexPath];
        }
        
    } else if (self.tableCategories) { //TAULA DE CATEGORIES
        
        //OBTENIM LA CELL
        UITableViewCell *cell = [tableView cellForRowAtIndexPath:indexPath];
        
        if (cell.accessoryType == UITableViewCellAccessoryNone) { //NO ESTA SELECCIONADA
            
            [cell setAccessoryType:UITableViewCellAccessoryCheckmark]; //SELECCIONA CELL
            
            //ACTUALITZA CELL SELECCIONADA
            UITableViewCell *oldCell = [tableView cellForRowAtIndexPath:self.currentSel];
            [oldCell setAccessoryType:UITableViewCellAccessoryNone];
            self.currentSel = indexPath;
            
            //ENVIA INFORMACIÓ A TRAVÉS DEL SEU DELEGAT
            [self.delegate OptionsSearchTableViewController:self didSelectedCategory:cell.textLabel.text indexPath:indexPath];
        }
        
    }
    
    [tableView deselectRowAtIndexPath:indexPath animated:YES];
    
}

//MÈTODE PER ACCEPTAR SELECCIÓ I TORNAR ENRERE
-(void)returnBack
{

    [self.navigationController popToRootViewControllerAnimated:YES];
}

#pragma mark NSURLConnection Delegate Methods

-(void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response
{
    self.responseData = [[NSMutableData alloc] init];
}

-(void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data
{
    [self.responseData appendData:data];
}

-(NSCachedURLResponse *)connection:(NSURLConnection *)connection willCacheResponse:(NSCachedURLResponse *)cachedResponse
{
    return nil;
}

-(void)connectionDidFinishLoading:(NSURLConnection *)connection
{
    //DADES REBUDES PER TANT FINALITZA FEEDBACK
    [self.ai stopAnimating];
    [self.ai removeFromSuperview];
    

    NSError *error;
    
    if (self.tablePobles) { //TAULA POBLES
        
        if (self.responseData != nil) { //S'HAN REBUT DADES
            
            //INICIA ARRAY POBLES
            NSMutableArray *llistaPobles = [[NSMutableArray alloc] initWithObjects:@"Tots els pobles", nil];
            
            //OBTENIM VALOR DE LES DADES REBUDES
            NSArray *JSONObjects = [NSJSONSerialization JSONObjectWithData:self.responseData
                                                                   options:NSJSONReadingAllowFragments
                                                                     error:&error];
            
            if (JSONObjects != nil) {
                
                for (NSDictionary *dict in JSONObjects) { //OBTENIM NOMS DELS POBLES
                    
                    //AFEGEIX AL ARRAY
                    [llistaPobles addObject:[dict objectForKey:@"poblacio_activitat"]];
                }
                
                //ACTUALITZA INFORMACIÓ PER LA TAULA
                self.pobles = llistaPobles;
                
            }
            
        } else { //NO S'HAN REBUT DADES
            
            //MOSTRAR ALERTA
            UIAlertView *theAlert = [[UIAlertView alloc] initWithTitle:@"Error"
                                                               message:@"Problema amb la connexió. No s'ha pogut obtenir informació dels pobles"
                                                              delegate:self
                                                     cancelButtonTitle:@"OK"
                                                     otherButtonTitles:nil];
            [theAlert show];
            
        }
        
    } else if (self.tableCategories) { //TAULA CATEGIRIES
        
        if (self.responseData != nil) { //S'HAN REBUT DADES
            
            //INICIAR ARRAY CATEGORIES
            NSMutableArray *llistaCategories = [[NSMutableArray alloc] initWithObjects:@"Totes les categories", nil];
            
            //OBTENIM VALOR DE LES DADES REBUDES
            NSArray *JSONObjects = [NSJSONSerialization JSONObjectWithData:self.responseData
                                                                   options:NSJSONReadingAllowFragments
                                                                     error:&error];
            
            if (JSONObjects != nil) {
                
                if (![[JSONObjects objectAtIndex:0] isEqual: @"0"]) { //HI HA CATEGORIES
                    
                    for (NSDictionary *dict in JSONObjects) { //OBTENIM NOMS DE LES CATEGORIES
                        
                        //AFEGEIX AL ARRAY DE CATEGORIES
                        [llistaCategories addObject:[dict objectForKey:@"categoria_activitat"]];
                    }
                    
                    //ACTUALITZA INFORMACIÓ PER LA TAULA
                    self.categories = llistaCategories;
                    
                } else { //NO HI HA CATEGORIES
                    
                    //MOSTRAR ALERTA
                    UIAlertView *theAlert = [[UIAlertView alloc] initWithTitle:@"Error"
                                                                       message:@"No hi ha categories per als filters seleccionats"
                                                                      delegate:self
                                                             cancelButtonTitle:@"OK"
                                                             otherButtonTitles:nil];
                    [theAlert show];
                    
                }
                
            }
            
        } else { //NO S'HAN REBUT DADES
            
            //MOSTRAR ALERTA
            UIAlertView *theAlert = [[UIAlertView alloc] initWithTitle:@"Error"
                                                               message:@"Problema amb la connexió. No s'ha pogut obtenir informació de les categories"
                                                              delegate:self
                                                     cancelButtonTitle:@"OK"
                                                     otherButtonTitles:nil];
            [theAlert show];
            
        }
        
        
        
    }
    
    //ACTUALITZAR TAULA
    [self.tableView reloadData];
    
}

-(void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error
{
    //ERROR PER TANT FINALITZA FEEDBACK
    [self.ai stopAnimating];
    [self.ai removeFromSuperview];
    
    if (self.tablePobles) { //TAULA POBLES
        
        //ALERTA POBLES
        UIAlertView *theAlert = [[UIAlertView alloc] initWithTitle:@"Error"
                                                           message:@"Problema amb la connexió. No s'ha pogut obtenir informació dels pobles"
                                                          delegate:self
                                                 cancelButtonTitle:@"OK"
                                                 otherButtonTitles:nil];
        [theAlert show];
    
    } else if (self.tableCategories) { //TAULA CATEGORIES
        
        //ALERTA CATEGORIES
        UIAlertView *theAlert = [[UIAlertView alloc] initWithTitle:@"Error"
                                                           message:@"Problema amb la connexió. No s'ha pogut obtenir informació de les categories"
                                                          delegate:self
                                                 cancelButtonTitle:@"OK"
                                                 otherButtonTitles:nil];
        [theAlert show];
        
    }
    
    
}


@end
