/*
 This file is part of GACC.
 
 GACC is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 GACC is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */
//
//  XPSRegistreViewController.m
//  Gacc
//
//  Created by Xavi Pregona Soto on 4/5/15.
//  Copyright (c) 2015 XPS. All rights reserved.
//

#import "XPSRegistreViewController.h"
#import "IniciViewController.h"

@interface XPSRegistreViewController () <NSURLConnectionDelegate>

//FEEDBACK PER L'USUARI PER QUE SAPIGA QUE L'APLICA ESTÀ CARREGANT LES DADES
@property (strong, nonatomic) UIActivityIndicatorView *ai;

@end

@implementation XPSRegistreViewController

-(id) init
{
    //ASSIGNEM TÍTOL A LA VISTA
    if (self = [super init]) {
        self.title = @"Registra't";
    }
    
    return self;
}

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
    
    self.navigationController.navigationBar.tintColor = [UIColor whiteColor];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

-(IBAction)userRegistration:(id)sender
{
    
    if (![self mailValidate:self.mail.text]) { //VALIDA MAIL MOSTRA UNA ALERTA A L'USUARI EN CAS QUE NO TINGUI UN FORMAT CORRECTE
        
        UIAlertView *theAlert = [[UIAlertView alloc] initWithTitle:@"Error"
                                                           message:@"El mail introduit no te un format vàlid."
                                                          delegate:self
                                                 cancelButtonTitle:@"OK"
                                                 otherButtonTitles:nil];
        
        [theAlert show];

        
    } else if ([self.password.text length] < 4) { //LONGITUD MÍNIMA DEL PASSWORD DE 5 CARÀCTERS
        
        UIAlertView *theAlert = [[UIAlertView alloc] initWithTitle:@"Error"
                                                           message:@"Password amb un mínim de 5 caràcters."
                                                          delegate:self
                                                 cancelButtonTitle:@"OK"
                                                 otherButtonTitles:nil];
        
        [theAlert show];
        
    } else if (![self.password.text isEqualToString:self.password2.text]) { //COMPROBA QUE EL PASSWORD I LA SEVA CONFIRMACIÓ SÓN IDÈNTICS
        
        UIAlertView *theAlert = [[UIAlertView alloc] initWithTitle:@"Error"
                                                           message:@"Els passwords no coincideixen. Revisa que siguin correctes."
                                                          delegate:self
                                                 cancelButtonTitle:@"OK"
                                                 otherButtonTitles:nil];
        
        [theAlert show];
    
    
    } else { //DADES CORRECTES
     
        //PREPARACIO SOL·LICITUD AL SERVEI WEB AFEGIR NOU USUARI
        NSString *userData = [NSString stringWithFormat:@"mail=%@&password=%@&password2=%@", self.mail.text, self.password.text, self.password2.text];
        NSData *postUserData = [userData dataUsingEncoding:NSUTF8StringEncoding];
        NSString *postLength = [NSString stringWithFormat:@"%lu", (unsigned long)[postUserData length]];
        
        NSMutableURLRequest *request = [[NSMutableURLRequest alloc] init];
        [request setURL:[NSURL URLWithString:@"http://gacc.esy.es/register.php"]];
        [request setHTTPMethod:@"POST"];
        [request setValue:postLength forHTTPHeaderField:@"Content-Length"];
        [request setValue:@"application/x-www-form-urlencoded" forHTTPHeaderField:@"Content-Type"];
        [request setHTTPBody:postUserData];
        
        //CONNEXIO ASÍNCRONA
        NSURLConnection *conn = [[NSURLConnection alloc] initWithRequest:request delegate:self];
        [conn start];
        
        //INDICADOR PER DONCAR FEEDBACK A L'USUARI QUE S'ESTAN CARREGANT LES DADES
        self.ai = [[UIActivityIndicatorView alloc] initWithActivityIndicatorStyle:UIActivityIndicatorViewStyleGray];
        self.ai.frame = CGRectMake(self.view.frame.size.width / 2.0, (self.view.frame.size.height / 2) - 150, 0, 0);
        CGAffineTransform transform = CGAffineTransformMakeScale(2.0f, 2.0f);
        self.ai.transform = transform;
        [self.ai startAnimating];
        [self.view addSubview:self.ai];
        
        }
    
}

//MÈTODE PER VALIDAR EMAIL
-(BOOL) mailValidate:(NSString *)tempMail
{
    BOOL stricterFilter = YES;
    NSString *stricterFilterString = @"[A-Z0-9a-z\\._%+-]+@([A-Za-z0-9-]+\\.)+[A-Za-z]{2,4}";
    NSString *laxString = @".+@([A-Za-z0-9]+\\.)+[A-Za-z]{2}[A-Za-z]*";
    NSString *emailRegex = stricterFilter ? stricterFilterString : laxString;
    NSPredicate *emailTest = [NSPredicate predicateWithFormat:@"SELF MATCHES %@", emailRegex];
    return [emailTest evaluateWithObject:tempMail];
}

//MÈTODE PER AMAGAR TECLAT QUAN ES PREM SOBRE ALGUN PUNT DE LA PANTALLA
- (void) touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event
{
    [[self view] endEditing:YES];
}

#pragma mark NSURLConnection Delegate Methods

-(void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response
{
    self.responseData = [[NSMutableData alloc] init];
}

-(void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data
{
    [self.responseData appendData:data];
}

-(NSCachedURLResponse *)connection:(NSURLConnection *)connection willCacheResponse:(NSCachedURLResponse *)cachedResponse
{
    return nil;
}

-(void)connectionDidFinishLoading:(NSURLConnection *)connection
{
    //DADES REBUDES PER TANT FINALITZA FEEDBACK
    [self.ai stopAnimating];
    [self.ai removeFromSuperview];
    
    NSError *error;
    
    if (self.responseData != nil) { //S'HAN REBUT DADES
        
        //OBTENIM EL VALOR DE LES DADES REBUDES
        NSDictionary *value = [NSJSONSerialization JSONObjectWithData:self.responseData
                                                              options:NSJSONReadingAllowFragments
                                                                error:&error];
        
        //VALOR RETORNAT QUE INDICA SI EL REGISTRE S'HA FET AMB ÈXIT
        NSString *successValue = [value objectForKey:@"success"];
        
        //VALOR RETORNAT QUE INDICA EL NÚMERO DE L'ERROR
        NSString *errorValue = [value objectForKey:@"error"];
        
        if ([successValue isEqualToString:@"0"]) { //NO S'HA POGUT FER EL REGISTRE
            
            if ([errorValue isEqualToString:@"1062"]) { //EMAIL JA EXISTEIX A LA BBDD
                
                UIAlertView *theAlert = [[UIAlertView alloc] initWithTitle:@"Error"
                                                                   message:@"L'usuari ja existeix"
                                                                  delegate:self
                                                         cancelButtonTitle:@"OK"
                                                         otherButtonTitles:nil];
                [theAlert show];
                
            } else { //PROBLEMA AMB EL SERVIDOR
                
                UIAlertView *theAlert = [[UIAlertView alloc] initWithTitle:@"Error"
                                                                   message:@"Problema extern. Torna ha provar-ho d'aquí una estona"
                                                                  delegate:self
                                                         cancelButtonTitle:@"OK"
                                                         otherButtonTitles:nil];
                
                [theAlert show];
                
            }
            
        } else { //REGSITRE CORRECTE
            
            //GUARDEM DADES DE L'USUARI A NSUSERDEFAULTS
            NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
            [defaults setObject:self.mail.text forKey:@"userMail"];
            
            //CREEM ARRAY BUIT PER PODER EMMAGATZEMAR ACTIVITATS
            NSMutableArray *activitats = [[NSMutableArray alloc] init];
            NSData *encodedArray = [NSKeyedArchiver archivedDataWithRootObject:activitats];
            
            [defaults setObject:encodedArray forKey:@"favorits"];
            [defaults synchronize];
            
            //TORNA A LA PANTALLA D'INICI
            [self.navigationController popToRootViewControllerAnimated:YES];
        }
        
    } else { //NO S'HAN OBTINGUT DADES
        
        UIAlertView *theAlert = [[UIAlertView alloc] initWithTitle:@"Error"
                                                           message:@"Problema amb la connexió. No s'ha pogut fer el registre"
                                                          delegate:self
                                                 cancelButtonTitle:@"OK"
                                                 otherButtonTitles:nil];
        
        [theAlert show];
        
    }

    
}

-(void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error
{
    //ERROR PER TANT FINALITZA FEEDBACK
    [self.ai stopAnimating];
    [self.ai removeFromSuperview];
    
    //MOSTRAR MISSATGE DE ERROR
    UIAlertView *theAlert = [[UIAlertView alloc] initWithTitle:@"Error"
                                                       message:@"Problema amb la connexió. No s'ha pogut fer el registre"
                                                      delegate:self
                                             cancelButtonTitle:@"OK"
                                             otherButtonTitles:nil];
    [theAlert show];
}


@end
