/*
 This file is part of GACC.
 
 GACC is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 GACC is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */
//
//  CercaTestCase.m
//  Gacc
//
//  Created by Xavi Pregona Soto on 18/5/15.
//  Copyright (c) 2015 XPS. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <XCTest/XCTest.h>
#import "XPSCercaTableTableViewController.h"

@interface CercaTestCase : XCTestCase

@property (nonatomic, strong) XPSCercaTableTableViewController *cerca;

@end

@implementation CercaTestCase

- (void)setUp {
    [super setUp];
    // Put setup code here. This method is called before the invocation of each test method in the class.
    
    self.cerca = [[XPSCercaTableTableViewController alloc] init];
}

- (void)tearDown {
    // Put teardown code here. This method is called after the invocation of each test method in the class.
    [super tearDown];
}

- (void)testNilProperties {
    // TEST AMB TOTES LES PROPIETATS A NIL
    self.cerca.provincia = nil;
    self.cerca.poble = nil;
    self.cerca.category = nil;
    self.cerca.date = nil;
    
    XCTAssertNoThrow([self.cerca searchActivities], @"NIL PROPERTIES OK");
}

- (void)testBadCategory {
    // TEST AMB UNA CATEGORIA SENSE ACTES EN EL POBLE INDICAT
    self.cerca.provincia = @"Lleida";
    self.cerca.poble = @"Agramunt";
    self.cerca.category = @"Altres"; //NO HI HA ACTES DE LA CATEGORIA 'ALTRES' A LA POBLACIÓ D'AGRAMUNT
    self.cerca.date = nil;
    
    XCTAssertNoThrow([self.cerca searchActivities], @"BAD CATEGORY OK");
}

- (void)testBadFutureDate {
    // TEST AMB UNA DATA FUTURA QUE NO TÉ ACTES
    self.cerca.provincia = @"Lleida";
    self.cerca.poble = @"Agramunt";
    self.cerca.category = nil;
    self.cerca.date = @"2016-05-18";
    
    XCTAssertNoThrow([self.cerca searchActivities], @"BAD FUTURE DATE OK");
}

- (void)testBadPastDate {
    // TEST AMB UNA DATA PASSADA QUE NO TÉ ACTES
    self.cerca.provincia = @"Lleida";
    self.cerca.poble = @"Agramunt";
    self.cerca.category = nil;
    self.cerca.date = @"2011-05-18";
    
    XCTAssertNoThrow([self.cerca searchActivities], @"BAD PAST DATE OK");
}

- (void)testPerformanceExample {
    // This is an example of a performance test case.
    [self measureBlock:^{
        // Put the code you want to measure the time of here.
    }];
}

@end
