<?php

require_once('ddbb.php');

//OBTENIM DADES ENVIADES DE L'APLICACIÓ
$latitud_usuari = $_GET['latitud'];
$longitud_usuari = $_GET['longitud'];

//CONSULTA INFORMACIÓ NECESSÀRIA PER FER CÀLCUL DE DISTÀNCIA
$consulta = "SELECT id_activitat, latitud_activitat, longitud_activitat FROM gacc_activitats WHERE latitud_activitat <> 0 AND longitud_activitat <> 0";

//CONNEXIO I CONSULTA A LA BASE DE DADES
$dbConection = new ddbb();
$activitats = $dbConection->consulta($consulta);

//PREPAREM LES DADES OBTINGUDES DE LA BASE DE DADES
$j = 0;
$info_activitats=[];
while ($row = mysqli_fetch_array($activitats, MYSQLI_ASSOC)) {
	$info_activitats[$j] = $row;
	$j++;
}

//CÀLCUL DE LA DISTÀNCIA DE CADA ACTIVITAT
foreach ($info_activitats as $activitat) {
	
	$lat = $activitat['latitud_activitat'];
	$lng = $activitat['longitud_activitat'];

	//FORMULA DE HAVERSINE PER CALCULAR LA DISTÀNCIA ENTRE 2 PUNTS EN FUNCIÓ DE LA SEVA LATITUD I LONGITUD
	$distGrados = rad2deg(acos((sin(deg2rad($latitud_usuari))*sin(deg2rad($lat))) + (cos(deg2rad($latitud_usuari))*cos(deg2rad($lat))*cos(deg2rad($longitud_usuari-$lng)))));
	
	//OBTENIR DISTÀNCIA EN KM
	$km = $distGrados * 111.13384;

	$km = round($km, 2);

	//AFEGIM DISTÀNCIA A CADA ACTIVITAT
	$array_info[] = array($km,$activitat['id_activitat']);

}

//ORDENEM RESULTATS SEGONS DISTÀNCIA
array_multisort($array_info, SORT_ASC);

//ENS QUEDEM AMB ELS 50 PRIMERS RESULTATS
array_splice($array_info, 50);

foreach ($array_info as $info) {

	//ID DE LA ACTIVITAT QUE VOLEM RECUPERAR DE LA BASE DE DADES
	$id = $info[1]; 
	//CONSULTA A LA BBDD
	$cons = "SELECT * FROM gacc_activitats WHERE id_activitat = '$id'";
	$activitat = $dbConection->consulta($cons);
	//RECOLLIM ELS RESULTATS
	$activitat = mysqli_fetch_array($activitat, MYSQLI_ASSOC);
	//AFEGIM LA DISTÀNCIA CALCULADA EN PASSOS ANTERIORS
	$activitat['distancia_activitat'] = $info[0];
	//AFEGIM ACTIVITAT AL ARRAY GENERAL PER SER RETORNAT POSTERIORMENT
	$array_activitats[] = $activitat;

}

//RETORNEM DADES EN FORMAT JSON PER SER LLEGIDES A LA APP
if(!$array_activitats) {
	$dades = json_encode(0);
} else {
	$dades = json_encode($array_activitats);
}

print_r($dades);

//TANQUEM CONNEXIO AMB LA BASE DE DADES
$dbConection->closeConexion();

?>